#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin>>t;
    for(int k=0; k<t; k++)
    {


    int n;
    cin>>n;
    long long int a[n];
    long long int unos;
    for(int i=0; i<n; i++)
    {
        cin>>unos;
        a[i]=unos;
    }
    map<long long int, int> mesta;
    for(int i=0; i<n; i++)
    {
        cin>>unos;
        if(unos<0) mesta[abs(unos)]=-(i+1);
        else mesta[abs(unos)]=i+1;
    }
    bool ispunjava=true;
    int prvi, drugi, dm;
    for(int i=0; i<n; i++)
    {
        prvi=i;
        drugi=mesta[abs(a[prvi])];
        if(drugi<0)
        {
            drugi=-drugi;
            dm=-abs(a[prvi]);
        }
        else dm=abs(a[prvi]);
        drugi--;
        if(a[prvi]/dm<0)
        {
            if(abs(prvi-drugi)%2==0)
            {
                ispunjava=false;
                break;
            }
        }
        else
        {
            if(abs(prvi-drugi)%2!=0)
            {
                ispunjava=false;
                break;
            }
        }
    }
    if(ispunjava)
    {
        cout<<"DA"<<"\n";
    }
    else cout<<"NE"<<"\n";



    }


}